﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.Configuration;
using System.Web.Security;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;

public partial class Default : System.Web.UI.Page
{

    public string strCountryCode3
    {
        get
        {
            if (Session["strCountryCode3"] != null)
            {
                return (String)Session["strCountryCode3"];
            }
            return "US";
        }
        set
        {
            Session["strCountryCode3"] = value;
        }
    }



    public string strCultureValue
    {
        get
        {
            if (Session["CultureValue"] != null)
            {
                return (String)Session["CultureValue"];
            }
            return "en-US";
        }
        set
        {
            Session["CultureValue"] = value;
        }
    }
    public string strCurrencyValue
    {
        get
        {
            if (Session["CurrencyValue"] != null)
            {
                return (String)Session["CurrencyValue"];
            }
            return "USD";
        }
        set
        {
            Session["CurrencyValue"] = value;
        }
    }
    public string strCountryValue
    {
        get
        {
            if (Session["CountryValue"] != null)
            {
                return (String)Session["CountryValue"];
            }
            return "US";
        }
        set
        {
            Session["CountryValue"] = value;
        }
    }
    public string strDateFormat
    {
        get
        {
            if (Session["DateFormat"] != null)
            {
                return (String)Session["DateFormat"];
            }
            return "M/d/yyyy";
        }
        set
        {
            Session["DateFormat"] = value;
        }
    }

    public string strADDomain
    {
        get
        {
            if (Session["strADDomain"] != null)
            {
                return (String)Session["strADDomain"];
            }
            return "us.parker.corp";
        }
        set
        {
            Session["strADDomain"] = value;
        }
    }
    private string strCultureValue01;
    private string strCurrencyValue01;
    private string strCountryValue01;
    private string strDateFormat01;
    private DataTable dtCultureTable01 = new DataTable();

    private int intGYear = 0;
    private int intGMonth = 0;
    private int intGDay = 0;
    private string strGDate = String.Empty;
    private string strFormat = String.Empty;

    
    #region PagePreRender

    protected void Page_PreRender(object sender, EventArgs e)
    {
        //ContentPlaceHolder mpContentPlaceHolder;
        //TextBox mpTextBox;
        //mpContentPlaceHolder =
        //  (ContentPlaceHolder)Master.FindControl("ContentPlaceHolder1");
        //HiddenField SourceTextBox = (HiddenField)this.Master.FindControl("hdfCurrencyCode");
        //txtDebug.Text txtGroup.Text txtDiv.Text txtLoc.Text

        //MKS 271677 Start
        CultureInfo cltUICulture = new CultureInfo(strCultureValue);
        DateTimeFormatInfo dtfSelectedDateTimeFormat = cltUICulture.DateTimeFormat;
        string strInputDateFormat = dtfSelectedDateTimeFormat.ShortDatePattern.ToString();
        strInputDateFormat = strDateFormat;
        Page.Culture = cltUICulture.Name;
        Page.UICulture = cltUICulture.Name;
    }//End of Page_PreRender Method

    #endregion // Page_PreRender Method




    protected void Page_Load(object sender, EventArgs e)
    {

        if (!IsPostBack)
        {
            IntializedtCultureTable01Table();
            BindCBXWithDataTable(dtCultureTable01, "RegionName", "Name", ref cmbCulture, txtSelectedCultureNameValue.Text);
            string[] languages = HttpContext.Current.Request.UserLanguages;
                string language = languages[0].ToLowerInvariant().Trim();
                CultureInfo cltCultureFromLanguage = new System.Globalization.CultureInfo(language);//MKS 271677
                if (Session["CultureValue"] == null)
                {
                    if (!string.IsNullOrEmpty(language))
                    {
                        System.Threading.Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo(language);
                        System.Threading.Thread.CurrentThread.CurrentCulture = System.Globalization.CultureInfo.CreateSpecificCulture(language);
                    }
                    txtSelectedCultureNameValue.Text = cltCultureFromLanguage.Name;//MKS 271677
                    BindCBXWithDataTable(dtCultureTable01, "RegionName", "Name", ref cmbCulture, txtSelectedCultureNameValue.Text);  //TODO 06/20/18 After selecting a New Value need to set the Selected Fields properly!
                }
        }

        CultureInfo cltUICulture = new CultureInfo(strCultureValue);
        DateTimeFormatInfo dtfSelectedDateTimeFormat = cltUICulture.DateTimeFormat;
        string strInputDateFormat = dtfSelectedDateTimeFormat.ShortDatePattern.ToString();
        strInputDateFormat = strDateFormat;
        Page.Culture = cltUICulture.Name;
        Page.UICulture = cltUICulture.Name;
    }


    #region IntializedtCultureTable01Table
    private void IntializedtCultureTable01Table()
    {

        if (IsDataTableNull(dtCultureTable01))
        {
            dtCultureTable01 = new DataTable();
            dtCultureTable01.Columns.Add("Name", typeof(string));
            dtCultureTable01.Columns.Add("LCID", typeof(string));
            dtCultureTable01.Columns.Add("RegionName", typeof(string));
            dtCultureTable01.Columns.Add("RegionISOName", typeof(string));//DecimalSeparator ThousandSeparator DateFormat
            dtCultureTable01.Columns.Add("DecimalSeparator", typeof(string));
            dtCultureTable01.Columns.Add("ThousandSeparator", typeof(string));
            dtCultureTable01.Columns.Add("DateFormat", typeof(string));
            System.Globalization.CultureInfo[] cultures = System.Globalization.CultureInfo.GetCultures(CultureTypes.AllCultures);
            foreach (System.Globalization.CultureInfo ci in cultures)
            {
                try
                {
                    CultureInfo cltUICulture = new CultureInfo(ci.Name);
                    RegionInfo riRegionInfo = new RegionInfo(ci.Name);
                    DateTimeFormatInfo dtDateTimeFormat = cltUICulture.DateTimeFormat;// CultureInfo.CreateSpecificCulture(cltUICulture).DateTimeFormat;
                    string strInputDateFormat = dtDateTimeFormat.ShortDatePattern.ToString();

                    DataRow drCultureRow = dtCultureTable01.NewRow();
                    drCultureRow["Name"] = ci.Name;
                    string strCIName = ci.Name;//MKS 271677 10/08/2018
                    int intIndexOfDash = strCIName.IndexOf("-");//MKS 271677 10/08/2018
                    drCultureRow["LCID"] = ci.LCID;
                    drCultureRow["RegionName"] = riRegionInfo.EnglishName;
                    drCultureRow["RegionISOName"] = riRegionInfo.TwoLetterISORegionName;
                    drCultureRow["DecimalSeparator"] = ci.NumberFormat.CurrencyDecimalSeparator;
                    drCultureRow["ThousandSeparator"] = ci.NumberFormat.NumberGroupSeparator;
                    drCultureRow["DateFormat"] = strInputDateFormat;
                    string expression = String.Format("USER_PREFIX= '{0}'", riRegionInfo.TwoLetterISORegionName.ToString());
                    dtCultureTable01.Rows.Add(drCultureRow);
                }
                catch (Exception ex)
                {

                    continue;
                }
            }
            dtCultureTable01.AcceptChanges();
            int intStartCount = dtCultureTable01.Rows.Count;
            int intEndCount = 0;
            if (dtCultureTable01.Rows.Count > 0)
            {
                //Convert DataTable to a Data View:
                DataView dv = dtCultureTable01.DefaultView;

                // Sort Data
                dv.Sort = "RegionName";

                //Convert back your sorted DataTable View to the DataTable:
                dtCultureTable01 = dv.ToTable();
                intEndCount = dtCultureTable01.Rows.Count;
            }
        }
    }//IntializedtCultureTable01Table End of Method
    #endregion //IntializedtCultureTable01Table End of Method

    #region IsDataTableNull
    private bool IsDataTableNull(DataTable table)
    {
        int intNoOfColumns = 0;
        if ((table == null) || (table.Rows.Count == 0))
        {

        }
        else
        {
            intNoOfColumns = 1;
        }
        //foreach (DataColumn column in table.Columns)
        //{
        //    intNoOfColumns++;
        //    var results = from myRow in table.AsEnumerable().Where 
        //    //where myRow.Field<int>("RowNo") == 
        //    if (table.Rows.OfType<DataRow>().Any(r => r.IsNull(column)))
        //        return true; //Means that it is NULL
        //}

        if (intNoOfColumns == 0)
        {
            return true; //Means that it is NULL
        }
        return false; //Means that it is full of data!
    }//IsDataTableNull End of Method
    #endregion //IsDataTableNull End of Method
    #region BindCBXWithDataTable
    private void BindCBXWithDataTable(DataTable ddtDataTable, string strTextColumn, string strValueColumn, ref RadComboBox cbxComBoxControl, string strSetSelectedValue)
    {
        DataTable _ddtDataTable = new DataTable();

        // Use Clone method to copy the table structure (Schema).
        _ddtDataTable = ddtDataTable.Clone();
        foreach (DataRow drDataRow in ddtDataTable.Rows)
        {
            _ddtDataTable.ImportRow(drDataRow);
        }
        RadComboBox _cbxComBoxControl = new RadComboBox();
        _cbxComBoxControl = cbxComBoxControl;
        _cbxComBoxControl.Items.Clear();
        _cbxComBoxControl.ClearSelection();
        _cbxComBoxControl.Text = string.Empty;
        _cbxComBoxControl.DataSource = _ddtDataTable;
        _cbxComBoxControl.DataTextField = strTextColumn;
        _cbxComBoxControl.DataValueField = strValueColumn;
        //cbxComBoxControl.Attributes.Add("DescriptionX", ddtDataTable.Select();
        _cbxComBoxControl.DataBind();
        if (String.IsNullOrEmpty(strSetSelectedValue))
        {
            //Do nothing if strSetSelectedValue is empty
        }
        else
        {
            //_cbxComBoxControl.SelectedIndex = -1;//MKS 10/09/2018
            _cbxComBoxControl.SelectedValue = strSetSelectedValue;
            //MKS 10/09/2018 Start:
            if (_cbxComBoxControl.SelectedIndex <= 0)
            {
                //No Item selected
                _cbxComBoxControl.SelectedIndex = 0;//MKS 10/09/2018
                switch (strValueColumn)
                {
                    case "Name":
                        strCultureValue = "UNK";
                        break;
                    case "USER_PREFIX":
                        strCountryValue = "UNK";
                        strCurrencyValue = "UNK";
                        break;
                    default:
                        break;
                }
            }

            else
            {
                var _cbxComBoxItem = _cbxComBoxControl.Items[_cbxComBoxControl.SelectedIndex];
                //_cbxComBoxControl.SelectedItem.Attributes.Keys

                switch (strValueColumn)
                {
                    case "Name":
                        string strMyAttributes = String.Empty;
                        string strMyAttributeValue = String.Empty;
                        foreach (string key in _cbxComBoxControl.SelectedItem.Attributes.Keys)
                        {
                            strMyAttributeValue = cmbCulture.SelectedItem.Attributes[key].ToString();
                            switch (key)
                            {
                                case "Name":
                                    txtSelectedCultureNameValue.Text = strMyAttributeValue;
                                    strCultureValue = strMyAttributeValue;
                                    break;
                                case "DateFormat":
                                    txtSelectedDateFormat.Text = strMyAttributeValue;
                                    strDateFormat = strMyAttributeValue;
                                    break;
                                case "DecimalSeparator":
                                    txtDecimalSeparator.Text = strMyAttributeValue;
                                    break;
                                case "ThousandSeparator":
                                    txtThousandSeparator.Text = strMyAttributeValue;
                                    break;
                                default:
                                    break;
                            }
                        }
                        //System.Collections.IEnumerator keys = _cbxComBoxControl.SelectedItem.Attributes.Keys.GetEnumerator();
                        //while (keys.MoveNext() == true)
                        //{
                        //    strMyAttributes = keys.Current.ToString();
                        //    strMyAttributeValue = _cbxComBoxControl.SelectedItem.Attributes[strMyAttributes];//txtSelectedDateFormat
                        //    switch (strMyAttributes)
                        //    {
                        //        case "Name":
                        //            txtSelectedCultureNameValue.Text = strMyAttributeValue;
                        //            strCultureValue = strMyAttributeValue;
                        //            break;
                        //        case "DateFormat":
                        //            txtSelectedDateFormat.Text = strMyAttributeValue;
                        //            strDateFormat = strMyAttributeValue;
                        //            break;
                        //        case "DecimalSeparator":
                        //            txtDecimalSeparator.Text = strMyAttributeValue;
                        //            break;
                        //        case "ThousandSeparator":
                        //            txtThousandSeparator.Text = strMyAttributeValue;
                        //            break;
                        //        default:
                        //            break;
                        //    }
                        //}
                        break;
                    default:
                        break;
                }//End of Switch Statement
            }
        }
        cbxComBoxControl = _cbxComBoxControl;
    }
    #endregion//BindCBXWithDataTable End of Method


    #region cmbCulture_SelectedIndexChanged
    protected void cmbCulture_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {
        txtSelectedCultureNameValue.Text = cmbCulture.SelectedValue.ToString();
        RadComboBoxItem comboBox = cmbCulture.SelectedItem as RadComboBoxItem;
        string strMyAttributes = String.Empty;
        string strMyAttributeValue = String.Empty;
        //Dictionary<string, string> KeyPairs = new Dictionary<string,int>();
        foreach (string key in cmbCulture.SelectedItem.Attributes.Keys)
        {
            strMyAttributeValue = cmbCulture.SelectedItem.Attributes[key].ToString();
            switch (key)
            {
                case "Name":
                    txtSelectedCultureNameValue.Text = strMyAttributeValue;
                    strCultureValue = strMyAttributeValue;
                    break;
                case "DateFormat":
                    txtSelectedDateFormat.Text = strMyAttributeValue;
                    strDateFormat = strMyAttributeValue;
                    break;
                case "DecimalSeparator":
                    txtDecimalSeparator.Text = strMyAttributeValue;
                    break;
                case "ThousandSeparator":
                    txtThousandSeparator.Text = strMyAttributeValue;
                    break;
                default:
                    break;
            }
        }
    }//cmbCulture_SelectedIndexChanged End of Method
    #endregion//cmbCulture_SelectedIndexChanged End of Method
    #region cmbCulture_DataBound
    protected void cmbCulture_DataBound(object sender, EventArgs e)
    {
        var combo = (RadComboBox)sender;
        combo.Items.Insert(0, new RadComboBoxItem("Select a Culture Name", string.Empty));
    }//cmbCulture_DataBound End of Method
    #endregion//cmbCulture_DataBound End of Method

    #region cmbCulture_ItemDataBound
    protected void cmbCulture_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
    {
        DataRowView dataSourceRow = (DataRowView)e.Item.DataItem;
        //set custom attributes from the datasource: 
        e.Item.Attributes["Name"] = dataSourceRow["Name"].ToString();
        e.Item.Attributes["LCID"] = dataSourceRow["LCID"].ToString();
        e.Item.Attributes["RegionName"] = dataSourceRow["RegionName"].ToString();
        e.Item.Attributes["RegionISOName"] = dataSourceRow["RegionISOName"].ToString();
        e.Item.Attributes["DecimalSeparator"] = dataSourceRow["DecimalSeparator"].ToString();
        e.Item.Attributes["ThousandSeparator"] = dataSourceRow["ThousandSeparator"].ToString();
        e.Item.Attributes["DateFormat"] = dataSourceRow["DateFormat"].ToString();
    }//cmbCulture_ItemDataBound End of Method
    #endregion//cmbCulture_ItemDataBound End of Method
    #region txtRequiredDeliveryDate_SelectedDateChanged
    protected void txtRequiredDeliveryDate_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        System.Globalization.Calendar calendarForControl = txtRequiredDeliveryDate.Culture.Calendar;
        DateTime x = new DateTime();
        DateTime datetimeReqDeliveryDateY = ConvertToDBDate(calendarForControl, txtRequiredDeliveryDate.SelectedDate.Value);
        txtResultingGregorianDate.Text = strGDate;
    }//txtRequiredDeliveryDate_SelectedDateChanged End of Method
    #endregion//txtRequiredDeliveryDate_SelectedDateChanged End of Method
    #region ConvertToDBDate
    protected DateTime ConvertToDBDate(System.Globalization.Calendar calendarForControl, DateTime DateTest)
    {

        System.Globalization.Calendar calendarGregorian = new GregorianCalendar();
        intGYear = calendarGregorian.GetYear(DateTest);
        intGMonth = calendarGregorian.GetMonth(DateTest);
        intGDay = calendarGregorian.GetDayOfMonth(DateTest);
        strGDate = intGMonth + "/" + intGDay + "/" + intGYear;
        strFormat = "MM/dd/yyyy";


        return DateTime.ParseExact(strGDate, strFormat, System.Globalization.CultureInfo.InvariantCulture);
    }//End of ConvertToDBDate
    #endregion//End of ConvertToDBDate
}
